mod application_error;
pub mod auth;
pub mod event_planning_template;
pub mod manage_commands;
pub mod password_change;
mod template_response_trait;
pub mod token_generation;

#[cfg(test)]
pub mod test_helper;

pub use application_error::ApplicationError;
use chrono::{NaiveDate, Utc};

pub use template_response_trait::TemplateResponse;

pub fn get_return_url_for_date(date: &NaiveDate) -> String {
    let today = Utc::now().date_naive();
    if date == &today {
        return String::from("/");
    }

    format!("/?date={}", date)
}
